diff -Naur --exclude=CVS --exclude=configs linux/hpc/comm.c linux-openmosix/hpc/comm.c
--- linux/hpc/comm.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-openmosix/hpc/comm.c	2002-12-29 16:29:28.000000000 +0100
@@ -0,0 +1,2108 @@
+/* Changes since Feb 12, 2002 by Moshe Bar
+ * Copyright (C) 2000, 2001, Amnon Barak (amnon@cs.huji.ac.il)
+ *
+ * Permission to use this software is hereby granted under the terms of the
+ * GNU General Public License, as published by the Free Software Foundation.
+ *
+ * Author(s): Oren Laadan, Moshe Bar
+ */
+
+
+#include <linux/sched.h>
+#include <linux/socket.h>
+#include <linux/poll.h>
+#include <net/sock.h>
+#include <hpc/routines.h>
+#include <hpc/defs.h>
+#include <linux/hpc.h>
+#include <linux/hpcctl.h>
+#include <linux/mm.h>
+#include <linux/stddef.h>
+#include <linux/smp_lock.h>
+#include <asm/pgtable.h>
+#include <hpc/protocol.h>
+#include <hpc/comm.h>
+#include <hpc/debug.h>
+#include <asm/uaccess.h>
+
+#ifdef CONFIG_MOSIX_DFSA
+#include <hpc/dfsa.h>
+#endif /* CONFIG_MOSIX_DFSA */
+
+#ifdef CONFIG_MOSIX_FS
+#include <linux/mfs.h>
+#include <linux/mfs_socket.h>
+#endif /* CONFIG_MOSIX_FS */
+
+#define MIG_DAEMON_PORT		0x3412
+#define INFO_DAEMON_PORT	0x3415
+
+/*
+ * mosix specific data per contact
+ */
+#define COMM_DEF_HEADSIZE	256
+
+struct mosix_link {
+	/* the first 2 elements are common to both types and must stay there */
+	struct socket *sock;	/* socket for communications */
+	int flags;		/* status flags */
+	int dlen;		/* length of pending data */
+	int peer;		/* mosix # of peer */
+	char *hideptr;		/* pointer to hidden data (current) */
+	char *hidebuf;		/* pointer to start of hidden data buffer */
+	int hidelen;		/* dlen of hidden data */
+	char head[COMM_DEF_HEADSIZE];
+};
+
+spinlock_t skown_lock = SPIN_LOCK_UNLOCKED;
+
+#define COMM_HEADINUSE		0x01
+#define COMM_WAITACCEPT		0x02
+#define COMM_HIDEDATA		0x04
+#define COMM_FULLLINK		0x08
+#define COMM_INFOLINK		0x10
+
+#define	COMM_MAX_MULTIWAIT	10
+
+#define COMM_SOCKET_SPARE	2048
+#define COMM_SOCKET_DATA	16384
+/*#define COMM_SOCKET_BUFFER	(COMM_SOCKET_SPARE + COMM_SOCKET_DATA)*/
+#define	COMM_SOCKET_BUFFER	131072
+
+
+
+
+
+#define COMM_REMOTE_TIMO	((unsigned long) 200*HZ) /* changed form 300 */
+#define COMM_CONNECT_TIMO	((unsigned long) 4*HZ)   /* changed from 5 */
+#define COMM_RECONN_TIMO	((unsigned long) 10*HZ)
+
+
+#ifdef CONFIG_MOSIX_DFSA
+#define	DISABLE_FLAGS	(DDEPUTY|DREMOTEDFSA)
+#else
+#define	DISABLE_FLAGS	DDEPUTY
+#endif /* CONFIG_MOSIX_DFSA */
+
+#define	DISABLE_EVENTS()	do {if(current->mosix.dflags & DISABLE_FLAGS) deeper_sleep();} while(0)
+#define	ENABLE_EVENTS()		do {if(current->mosix.dflags & DISABLE_FLAGS) lighter_sleep();} while(0)
+
+int comm_type;
+unsigned long comm_remote_timo = COMM_REMOTE_TIMO;	/* for remote accept */
+unsigned long comm_connect_timo = COMM_CONNECT_TIMO;	/* for connection */
+unsigned long comm_reconn_timo = COMM_RECONN_TIMO;	/* for reconnection */
+
+/*
+ * make sure that all pages in range cause no remote page-fault requests later.
+ * Once we find a page that would cause a page-fault, we may either report it
+ * by returning 0 (normal return is 1) or fix it and make it dirty.
+ */
+int
+dirty_all_remote_pages(unsigned long start, unsigned long size, int doit)
+{
+	struct mm_struct *mm = current->mm;
+	struct vm_area_struct * vma;
+	unsigned long addr, lastaddr;
+	unsigned long limit = (start + size + PAGE_SIZE - 1) & ~(PAGE_SIZE-1);
+	pgd_t *pgd;
+	pmd_t *pmd;
+	pte_t *pte;
+	unsigned int hidedata = 0;
+	int ret = 1;
+
+	if(size == 0)
+		return(1);
+	down_read(&mm->mmap_sem);
+	if(!(vma = find_vma(mm, start)))
+		goto unlock;
+	for(addr = start & ~(PAGE_SIZE-1) ; addr < limit ; addr += PAGE_SIZE)
+	{
+		while(!vma->vm_file || addr >= vma->vm_end ||
+			(doit && !(vma->vm_flags & VM_WRITE)))
+			/* (the last condition will cause a SIGSEGV,
+					   which we don't want here) */
+		{
+			lastaddr = vma->vm_end;
+			if(!(vma = vma->vm_next))
+				goto unlock;
+			if(vma->vm_file && (vma->vm_flags & VM_GROWSDOWN))
+			/* (a mad-hatter is permitted use sys_mmap this way) */
+			{
+				if((addr = lastaddr) >= limit)
+					goto unlock;
+			}
+			else if((addr = vma->vm_start) >= limit)
+				goto unlock;
+			addr = vma->vm_start;
+		}
+		if(vma->vm_flags & VM_GROWSDOWN)
+		  /* Hmmm... will any executable file-format ever allow this? */
+			panic("dirty_all_remote_pages: stack mapped to file");
+
+		/* Dirty pages (including swap) are OK - all others are not */
+		pgd = pgd_offset(current->mm, addr);
+		if(pgd_none(*pgd) || pgd_bad(*pgd) ||
+			pmd_none(*(pmd = pmd_offset(pgd, addr))) ||
+			pmd_none(*pmd) || pmd_bad(*pmd) ||
+			(pte_present(*(pte = pte_offset(pmd, addr))) ?
+				!pte_dirty(*pte) : pte_none(*pte)))
+		{
+			if(!doit)
+			{
+				ret = 0;
+				goto unlock;
+			}
+			if (!hidedata) {
+				hidedata = 1;
+				if(comm_hidedata())
+				{
+					ret = 0;
+					goto unlock;
+				}
+			}
+			handle_mm_fault(mm, vma, addr, 1);
+		}
+	}
+	unlock:
+	up_write(&mm->mmap_sem);
+	return(ret);
+}
+
+/*
+ * internal communication routines
+ */
+
+static void *comm_mkhead(int);
+static inline void comm_setup_link(mosix_link *, int);
+static inline void comm_unset_link(mosix_link *);
+static inline int comm_setup_socket(struct socket *, int);
+static inline void comm_unset_socket(struct socket *);
+static void *comm_malloc(int);
+static int comm_dorecv(struct socket *, struct msghdr *, int);
+static int comm_packregs(struct comm_header *, char *);
+static int comm_unpackregs(struct comm_header *, char *);
+static int comm_packident(char *);
+static int comm_unpackident(char *);
+static int comm_waitaccept(void);
+static int comm_poll(int, int, unsigned long);
+static void comm_data_ready(struct sock *, int);
+static int comm_getname(struct socket *, struct sockaddr *);
+static void comm_shutdown(mosix_link *);
+
+static inline struct socket *comm_set_address(int, struct sockaddr *, int);
+static inline struct socket *comm_ip_set_addr(int, struct sockaddr *, int);
+static inline int comm_ip_getname(struct socket *, struct sockaddr *);
+static inline int comm_ip_setup_socket(struct socket *, int);
+static void comm_ip_migration_mode(int);
+
+void
+comm_report_violation(char *desire, struct sockaddr *addr)
+{
+	unsigned int a = htonl(((struct sockaddr_in *)addr)->sin_addr.s_addr);
+
+	printk("Received an unauthorized %s request from %d.%d.%d.%d\n", desire,
+		(a & 0xff000000) >> 24, (a & 0xff0000) >> 16,
+		(a & 0xff00) >> 8, a & 0xff);
+}
+
+static inline struct task_struct *
+find_task_by_sock(struct socket *sock)
+{
+	struct task_struct *p = NULL;
+	struct sock *sk;
+
+	spin_lock(&skown_lock);
+	if((sk = sock->sk) && (p = sk->owner))
+		get_task_struct(p);
+	else
+		spin_unlock(&skown_lock);
+	return(p);
+}
+
+static inline void
+comm_setup_link(mosix_link *mlink, int peer)
+{
+	mlink->dlen = 0;
+	mlink->peer = peer;
+	mlink->hideptr = NULL;
+	mlink->hidebuf = NULL;
+	mlink->hidelen = 0;
+}	
+
+static inline void
+comm_unset_link(mosix_link *mlink)
+{
+	if (mlink->flags & COMM_FULLLINK) {
+		if (mlink->hidebuf) {
+			kfree(mlink->hidebuf);
+			mlink->hidebuf = NULL;
+			mlink->hideptr = NULL;
+			mlink->hidelen = 0;
+		}
+		mlink->dlen = 0;
+	}
+	mlink->flags &= ~(COMM_WAITACCEPT | COMM_HIDEDATA);
+}
+
+static void *
+comm_malloc(int size)
+{
+	void *mem;
+
+	while(1)
+	{
+		if((mem = kmalloc(size, GFP_KERNEL)))
+			return(mem);
+	}
+}
+
+static int
+comm_packregs(struct comm_header *header, char *ptr)
+{
+	int regs;
+	int bit;
+	int size = 0;
+	int *regptr = (int *)ptr;
+	struct task_struct *p = current;
+	regs = which_regs_to_send();
+	if (header)
+		header->regs = regs;
+	if (!regs)
+		return (0);
+
+	regs = ~regs;
+
+	while (regs != 0xffffffff) {
+		bit = ffz(regs);
+		if (ptr)
+			*(regptr++) = ((int *)p->mosix.altregs)[bit];
+		regs |= (1 << bit);
+		size++;
+	}
+	return (size << 2);	/* size * sizeof(int) */
+}
+
+
+static int
+comm_unpackregs(struct comm_header *header, char *ptr)
+{
+	int regs;
+	int bit;
+	int size = 0;
+	int *regptr = (int *)ptr;
+	struct task_struct *p = current;
+
+	regs = header->regs;
+	p->mosix.deputy_regs ^= regs;
+
+	regs = ~regs;
+	while (regs != 0xffffffff) {
+		bit = ffz(regs);
+		((int *)p->mosix.altregs)[bit] = *(regptr++);
+		regs |= (1 << bit);
+		size++;
+	}
+
+
+	return (size << 2);	/* size * sizeof(int) */
+}
+
+
+static int
+comm_packident(char *ptr)
+{
+	if (ptr) {
+		((int *)ptr)[0] = PE;
+		((int *)ptr)[1] = comm_getpeer(current->mosix.contact);
+
+		/*
+		 * if this is the first migration to a node,
+		 * tell them, so they flush any of our old cached files,
+		 */
+		if (!config_get_status(((int *)ptr)[1]))
+			((int *)ptr)[0] |= 0x80000000;
+
+	}
+	return (2 * sizeof(int));
+}
+
+
+static int
+comm_unpackident(char *ptr)
+{
+	int ret = -1;
+	int him, me;
+	him = ((int *)ptr)[0];
+	me = ((int *)ptr)[1];
+	
+	if (him & 0x80000000)
+		rinode_flush_files(him & ~0x80000000);
+	if (comm_getpeer(current->mosix.contact) == (him & 0x7fffffff)
+								 && PE == me)
+		ret = 2 * sizeof(int);
+
+	return (ret);
+}
+
+
+/*
+ * comm_startup() - initialize communication layer
+ */
+void
+comm_startup(void)
+{
+	/* nothing to do */
+}
+
+/*
+ * comm_setup_socket() - setup socket parameters (specific to its type)
+ */
+static inline int
+comm_setup_socket(struct socket *sock, int mos)
+{
+	int val;
+	int error;
+	int connect = 0;
+	mm_segment_t oldfs;
+
+	oldfs = get_fs();
+	set_fs(KERNEL_DS);
+
+	/*
+	 * socket parameters:
+	 * - SO_SNDBUF, SO_RCVBUF 
+	 * - SO_KEEPALIVE (for connection-oriented sockets)
+	 */
+
+	val = COMM_SOCKET_BUFFER;
+	if ((error = sock_setsockopt(sock, SOL_SOCKET, SO_SNDBUF,
+						(char *) &val, sizeof(val))) ||
+	    (error = sock_setsockopt(sock, SOL_SOCKET, SO_RCVBUF,
+	    					(char *) &val, sizeof(val))))
+		goto failed;
+/*
+	val = IPTOS_LOWDELAY;
+	if ((error = sock_setsockopt(sock, SOL_IP, IP_TOS, (char *)&val,
+								sizeof(val))))
+		goto failed;
+*/
+
+	switch (mos) {
+	case COMM_INFO:
+		sock->sk->data_ready = comm_data_ready;
+		break;
+	case COMM_LOOSE:
+		/* 
+		 * set "sk->bsdism" (SO_BSDCOMPAT) to prevent ICMP
+		 * errors from being reflected in the UDP socket,
+		 * thus receiving old errors on new calls.
+		 */
+		val = 1;
+		if ((error = sock_setsockopt(sock, SOL_SOCKET,
+					     SO_BSDCOMPAT, (char*)&val,sizeof(val))))
+			goto failed;
+	case COMM_ACCEPT:
+	case COMM_TOADDR:
+	default:
+		set_bit(SOCK_INTER_MOSIX, &sock->flags);
+		if (mos == COMM_LOOSE) /* UDP - we're done */
+			break;
+		val = 1;
+		if ((error = sock_setsockopt(sock, SOL_SOCKET,
+					     SO_KEEPALIVE, (char *) &val, sizeof(val))))
+			goto failed;
+		/* fall through */
+	case COMM_MIGD:
+		connect = 1;
+		val = 1;
+		break;
+	}
+
+	switch (comm_type) {
+	case AF_INET:
+		error = comm_ip_setup_socket(sock, connect);
+		break;
+	default:
+		panic("comm_setup_socket: unknown comm_type");
+	}
+
+ failed:
+	set_fs(oldfs);
+	return (error);
+}
+
+static inline void
+comm_unset_socket(struct socket *sock)
+{
+	spin_lock_irq(&skown_lock);
+	sock->sk->owner = NULL;
+	clear_bit(SOCK_INTER_MOSIX, &sock->flags);
+	spin_unlock_irq(&skown_lock);
+}
+
+
+static inline int
+comm_ip_setup_socket(struct socket *sock, int connect)
+{
+	int val;
+	int error;
+
+	/* NOTE: at this point set_fs(KERNEL_DS) is on */
+
+	if (connect) {
+		mm_segment_t oldfs = get_fs();
+		set_fs(KERNEL_DS);
+		val = MOSIX_CONNECTION_KEEPALIVE_INTERVAL;
+		if ((error = sock->ops->setsockopt(sock, IPPROTO_TCP,
+			TCP_KEEPINTVL, (char *) &val, sizeof(val))))
+		{
+			resume:
+			set_fs(oldfs);
+			return(error);
+		}
+		val = MOSIX_CONNECTION_KEEPALIVE_MAXTRIES;
+		if ((error = sock->ops->setsockopt(sock, IPPROTO_TCP,
+			TCP_KEEPCNT, (char *) &val, sizeof(val))))
+			goto resume;
+		val = MOSIX_CONNECTION_KEEPALIVE_TOTAL;
+		if ((error = sock->ops->setsockopt(sock, IPPROTO_TCP,
+			TCP_KEEPIDLE, (char *) &val, sizeof(val))))
+			goto resume;
+		val = 1;
+		if ((error = sock->ops->setsockopt(sock, IPPROTO_TCP,
+			TCP_NODELAY, (char *) &val, sizeof(val))))
+			goto resume;
+		set_fs(oldfs);
+	}
+	return (0);
+}
+
+/*
+ * comm_open() - open a socket for openMosix communications
+ * 
+ * mos > 0: 		connect to migdaemon on node #mos
+ * mos = COMM_TOADDR:	connect to address given in maddr->saddr
+ * mos = COMM_ACCEPT:	set up a socket and prepare to accept
+ * mos = COMM_MIGD:	set up a socket for mig-daemon
+ * mos = COMM_INFOD:	set up a socket for info-daemon
+ * mos = COMM_LOOSE	connect to multiple daemons
+ */
+mosix_link *
+comm_open(int mos, mosix_addr *maddr, unsigned long timo)
+{
+	int error = -EDIST;
+	struct socket *sock = NULL;
+	mosix_link *mlink = NULL;
+	struct sockaddr sa;
+	int connect = 1, bind = 1, need_comm = 1, listen = 1, peer = 0;
+	struct sockaddr *saddr = &(maddr->saddr);
+	DECLARE_WAITQUEUE(wait, current);
+
+	/*
+	 * COMM_INFO:	connect = 0, need_comm = 0, listen = 0, bind = 1
+	 * COMM_MIGD:	connect = 0, need_comm = 1, listen = 1, bind = 1
+	 * COMM_ACCEPT:	connect = 0, need_comm = 1, listen = 1, bind = 1
+	 * COMM_TOADDR: connect = 1, need_comm = 1, listen = 0, bind = 1
+	 * COMM_LOOSE:  connect = 0, need_comm = 0, listen = 0, bind = 0
+	 * deafult:     connect = 1, need_comm = 1, listen = 1, bind = 1
+	 */
+	switch (mos) {
+	case COMM_LOOSE:
+		bind = 0;
+		/* fall through */
+	case COMM_INFO:
+		listen = 0;
+		/* fall through */
+	case COMM_MIGD:
+		need_comm = 0;
+		/* fall through */
+	case COMM_ACCEPT:
+		connect = 0;
+		if(!saddr)
+			saddr = &sa;
+		break;
+	case COMM_TOADDR:
+		if(saddr->sa_family != AF_INET)
+			return(NULL);
+		break;
+	default:
+		peer = mos;
+		saddr = &sa;
+		break;
+	}
+	DISABLE_EVENTS();
+	/* fill in socket address and allocate a socket */
+	if (!(sock = comm_set_address(mos, saddr, 1)))
+		goto failed;
+
+	if (need_comm) {	 	/* mosix_link required ? */
+		mlink = kmalloc(sizeof(mosix_link), GFP_KERNEL);
+		if (!mlink) {
+		no_memory:
+			goto failed;
+		}
+		mlink->flags = COMM_FULLLINK;
+		comm_setup_link(mlink, peer);
+	} else {
+		mlink = kmalloc(sizeof(struct socket *) + sizeof(int),
+								GFP_KERNEL);
+		if (!mlink)
+			goto no_memory;
+		mlink->flags = COMM_INFOLINK;
+	}
+	mlink->sock = sock;
+	
+	if ((error = comm_setup_socket(sock, mos)))
+		goto failed;
+
+	if (!connect) { 			/* setup server - listen */
+		if(bind)
+		{
+			error = sock->ops->bind(sock, saddr, sizeof(*saddr));
+			if (error) {
+				if(error == -EADDRINUSE && mos == COMM_MIGD)
+					printk("Migration port (%d) Already in use\n", ntohs(MIG_DAEMON_PORT));
+				goto failed;
+			}
+		}
+		if (listen) {			/* connection required ? */
+			error = sock->ops->listen(sock, SOMAXCONN);
+			if (error) {
+				goto failed;
+			}
+		}
+
+		if (mos == COMM_ACCEPT) {
+			mlink->flags |= COMM_WAITACCEPT;
+			if ((error = comm_getname(sock, saddr))) {
+				goto failed;
+			}
+		}
+	} else {		/* setup client - connect */
+		if (!timo)
+			timo = MAX_SCHEDULE_TIMEOUT;
+		error = sock->ops->connect(sock, saddr, sizeof(*saddr),
+								O_NONBLOCK);
+		add_wait_queue(sock->sk->sleep, &wait);
+		while (sock->state != SS_CONNECTED) {
+			set_current_state(TASK_INTERRUPTIBLE);
+			error = sock->ops->connect(sock, saddr, sizeof(*saddr),
+								O_NONBLOCK);
+			if (error != -EALREADY || (error=sock_error(sock->sk)))
+				break;
+
+			timo = schedule_timeout(timo);
+			if (timo <= 0) {
+				error = -EAGAIN;
+				break;
+			}
+		}
+		remove_wait_queue(sock->sk->sleep, &wait);
+		set_current_state(TASK_RUNNING);
+
+		if (error) {
+			goto failed;
+		}
+		if (sock->sk->err) {
+			error = sock_error(sock->sk);	/* cleans error.. */
+			goto failed;
+		}
+		/* client socket ready */
+	}
+	ENABLE_EVENTS();
+
+	return (mlink);
+
+failed:
+	ENABLE_EVENTS();
+	if (sock)
+		sock_release(sock);
+	if (mlink)
+		kfree(mlink);
+	return (0);
+}
+
+/*
+ * comm_use() - set new "contact" for a process (and get the old one)
+ */
+mosix_link *
+comm_use(struct task_struct *p, mosix_link *mlink)
+{
+	mosix_link *oldmlink;
+
+	spin_lock_irq(&skown_lock);
+	if ((oldmlink = p->mosix.contact))
+		oldmlink->sock->sk->owner = NULL;
+	p->mosix.contact = NULL;
+	if (mlink)
+	{
+		p->mosix.contact = mlink;
+		mlink->sock->sk->owner = p;
+	}
+	spin_unlock_irq(&skown_lock);
+	if(test_bit(SOCK_OOB_IN, &mlink->sock->flags))
+		tell_process(p, DREQ_URGENT);
+	return (oldmlink);
+}
+
+
+/*
+ * comm_close() - close an openMosix communication socket
+ *   if called with NULL argument, close our contact and nullify it
+ */
+void
+comm_close(mosix_link *mlink)
+{
+	unsigned int ours = 0;
+
+	if (!mlink) {
+		ours = 1;
+		mlink = current->mosix.contact;
+	}
+
+	comm_shutdown(mlink);
+	sock_release(mlink->sock);
+
+	if (ours)
+		current->mosix.contact = NULL;
+
+	kfree(mlink);
+}
+
+
+/*
+ * comm_accept() - accept a connection on openMosix socket
+ */
+int
+comm_accept(mosix_link *ml, mosix_link **mlp, mosix_addr *ma, unsigned long t)
+{
+	int error = 0;
+	struct socket *sock;
+	struct sockaddr *saddr = &(ma->saddr);
+
+	if ((*mlp = kmalloc(sizeof(mosix_link), GFP_KERNEL)) == 0)
+		return (-ENOMEM);
+
+	sock = sock_alloc();
+	if (!sock) {
+		kfree(*mlp);
+		return (-EMFILE);
+	}
+	sock->type = ml->sock->type;
+	sock->ops = ml->sock->ops;
+
+	if (t && !comm_poll(POLLIN | POLLRDNORM, 0, t))
+		error = -EAGAIN;
+
+	if (!error)
+		error = ml->sock->ops->accept(ml->sock, sock, 0);
+
+	if (!error && saddr)
+		error = comm_getname(sock, saddr);
+
+	if (error) {
+	failed:
+		kfree(*mlp);
+		sock_release(sock);
+		*mlp = NULL;
+	} else {
+		struct sockaddr saddr;
+		int val;
+
+		if (sock->ops->getname(sock, &saddr, &val, 1)) {
+			error = -ENOTCONN;
+			goto failed;
+		}
+		if (!(val = net_to_mos((mosix_addr *)&saddr))) {
+			comm_report_violation("migration", &saddr);
+			error = -EDIST;
+			goto failed;
+		}
+		(*mlp)->sock = sock;
+		(*mlp)->flags = COMM_FULLLINK;
+		comm_setup_link(*mlp, val);
+
+		if ((error = comm_setup_socket(sock, PE)))
+			goto failed;	
+	}
+	return (error);
+}
+
+/*
+ * comm_waitaccept() - accept a connection on openMosix socket
+ */
+static int
+comm_waitaccept()
+{
+	struct task_struct *p = current;
+	mosix_link *mlink;
+	int error;
+
+	if ((error = comm_accept(p->mosix.contact, &mlink, 0, comm_remote_timo)))
+		return (error);
+
+	comm_close(comm_use(p, mlink));
+	return (0);
+}
+
+
+/*
+ * comm_free() - free a head/data which is no longer used
+ */
+void
+comm_free(void *head)
+{
+	mosix_link *mlink;
+	struct task_struct *p = current;
+
+	if(!head)
+		return;
+
+	mlink = p->mosix.contact;
+	if (mlink->flags & COMM_INFOLINK) {
+		kfree(head);
+		return;
+	}
+
+	if (head == &mlink->head + COMM_HLEN) {
+		mlink->flags &= ~COMM_HEADINUSE;
+		goto out;
+	} else if (head == &(mlink->head)) {
+		/* default head is (supposedly) in use */
+		mlink->flags &= ~COMM_HEADINUSE;
+		goto out;
+	} else {
+		/* must be a head we previously allocated */
+		kfree(head);
+		return;
+	}
+
+	mosix_panic("comm_free() # 1");
+
+out:
+
+}
+
+
+/*
+ * comm_mkhead() - prepares a head of size hlen
+ */
+void *
+comm_mkhead(int hlen)
+{
+	mosix_link *mlink;
+	void *head;
+
+	mlink = current->mosix.contact;
+
+	if ((mlink->flags & COMM_HEADINUSE) || hlen > COMM_DEF_HEADSIZE) {
+		head = kmalloc(hlen, GFP_KERNEL);
+		if(!head)
+			return(NULL);
+		return (head);
+	}
+
+	head = &mlink->head;
+	mlink->flags |= COMM_HEADINUSE;
+	return (head);
+}
+
+#define CMHDR(x)		((struct comm_header *)x)
+
+static char bigbuf[PAGE_SIZE], midbuf[512], smallbuf[128];
+static int bigtaken, midtaken, smalltaken;
+
+/*
+ * comm_send() - send a message (head + data)
+ */
+int
+comm_send(int type, void *head, int hlen, void *data, int dlen, int uspace)
+{
+	mosix_link *mlink;
+#ifdef CONFIG_MOSIX_DFSA
+	struct comm_header header = { 0, 0, 0, 0, 0, 0 };
+	struct iovec iov[4];
+	int dfsalen = 0;
+	char *dfsadata = NULL;
+#else
+	struct comm_header header = { 0, 0, 0, 0, 0, 0 };
+	struct iovec iov[3];
+#endif /* CONFIG_MOSIX_DFSA */
+	struct msghdr msg = { NULL, 0, iov, 0, NULL, 0, MSG_NOSIGNAL };
+	mm_segment_t oldfs = { 0 };
+	int niov = 1;
+	int size = 0;
+	void *free_head = 0;
+	int error = -ENOMEM;
+	void *tofree = NULL;
+	int *tozero = NULL;
+	void *kerdat;
+
+	if(uspace && !dirty_all_remote_pages((unsigned long)data, dlen, 0))
+	{
+		if(!smalltaken && dlen <= sizeof(smallbuf))
+		{
+			kerdat = smallbuf;
+			smalltaken = 1;
+			tozero = &smalltaken;
+		}
+		else if(!midtaken && dlen <= sizeof(midbuf))
+		{
+			kerdat = midbuf;
+			midtaken = 1;
+			tozero = &midtaken;
+		}
+		else if(!bigtaken && dlen <= sizeof(bigbuf))
+		{
+			kerdat = bigbuf;
+			bigtaken = 1;
+			tozero = &bigtaken;
+		}
+		else if(!(kerdat = tofree = kmalloc(dlen, GFP_KERNEL)))
+			return(-ENOMEM);
+		if(copy_from_user(kerdat, data, dlen))
+		{
+			if(tofree)
+				kfree(tofree);
+			return(-EFAULT);
+		}
+		uspace = 0;
+		data = kerdat;
+	}
+	DISABLE_EVENTS();
+
+	if(current->mosix.pass_regs)
+		type |= COMM_MFREGS;
+
+#ifdef CONFIG_MOSIX_DFSA
+	dfsa_check_comm_send(&type, &dfsadata, &dfsalen);
+	if(dfsalen < 0)
+	{
+		error = dfsalen;
+		goto failed;
+	}
+#endif /* CONFIG_MOSIX_DFSA */
+
+	if (current->mosix.dflags & DREMOTE)
+		current->mosix.dflags |= DPSYNC;
+
+	mlink = current->mosix.contact;
+
+	/* validate address range if in user-space (EFAULT ?) */
+	/*if (data && uspace && !access_ok(VERIFY_READ, data, dlen)) {*/
+	if (data && uspace && !ucache_ok((unsigned long)data, dlen, VM_READ)) {
+		error = -EFAULT;
+		goto failed;
+	}
+
+	if (type & COMM_MFREGS)
+	{
+		if (!(size = comm_packregs(0, 0))) {
+			type &= ~COMM_MFREGS;
+			regs_were_sent();
+		}
+	}
+	if (type & COMM_MFIDENT)
+		size += comm_packident(0);
+	if (!size) {
+		header.type = type;
+		header.hlen = (u_short) hlen;
+		iov[0].iov_base = &header;
+		iov[0].iov_len  = COMM_HLEN;
+		iov[1].iov_base = head;
+		iov[1].iov_len  = hlen;
+		niov++;
+	} else {
+		char *options;
+
+		/* allocate space for options - use default buffer if free */
+		size += COMM_HLEN;
+		iov[0].iov_len = size;
+		if ((mlink->flags & COMM_HEADINUSE) || size>COMM_DEF_HEADSIZE){
+			free_head = iov->iov_base = kmalloc(size, GFP_KERNEL);
+			if (!iov->iov_base)
+				goto failed;	/* xxx - error set above */
+		} else {
+			free_head = iov->iov_base = mlink->head;
+			mlink->flags |= COMM_HEADINUSE;
+		}
+		options = iov->iov_base + COMM_HLEN;
+		size = 0;
+		if (type & COMM_MFREGS)
+			size += comm_packregs(CMHDR(iov->iov_base), options);
+		if (type & COMM_MFIDENT)
+			size += comm_packident(options + size);
+		CMHDR(iov->iov_base)->type = type;
+		CMHDR(iov->iov_base)->hlen = (u_short) hlen;
+		iov[1].iov_base = head;
+		iov[1].iov_len  = hlen;
+		niov++;
+	}
+	CMHDR(iov->iov_base)->olen = size;
+	CMHDR(iov->iov_base)->dlen = 0;
+	size += COMM_HLEN + hlen;
+#ifdef CONFIG_MOSIX_DFSA
+	CMHDR(iov->iov_base)->dfsalen = dfsalen;
+	if(dfsalen)
+	{
+		iov[niov].iov_base = dfsadata;
+		iov[niov].iov_len = dfsalen;
+		size += dfsalen;
+		niov++;
+	}
+#else
+	CMHDR(iov->iov_base)->dfsalen = 0;
+#endif /* CONFIG_MOSIX_DFSA */
+	if (data) {
+		CMHDR(iov->iov_base)->type |= COMM_MFDATA;
+		CMHDR(iov->iov_base)->dlen = dlen;
+		iov[niov].iov_base = data;
+		iov[niov].iov_len  = dlen;
+		size += dlen;
+		niov++;
+	}
+
+	msg.msg_iovlen = niov;
+	oldfs = get_fs();
+	set_fs(KERNEL_DS);
+	error = mlink->sock->ops->sendmsg(mlink->sock, &msg, size, NULL);
+	set_fs(oldfs);
+
+	if (free_head)
+		comm_free(free_head);
+
+	if((type & COMM_MFREGS) && error >= 0)
+		regs_were_sent();
+failed:
+	ENABLE_EVENTS();
+#ifdef CONFIG_MOSIX_DFSA
+	if (dfsadata)
+		kfree(dfsadata);
+#endif /* CONFIG_MOSIX_DFSA */
+	if(tofree)
+		kfree(tofree);
+	if(tozero)
+		*tozero = 0;
+	return (error < 0 ? error : 0);
+}
+
+
+/*
+ * comm_dorecv() - reliably read data from socket
+ *   on success, or if error == -EFAULT: returns number of bytes received
+ *   otherwise (any other error): returns negative error.
+ */
+static int
+comm_dorecv(struct socket *sock, struct msghdr *msg, int len)
+{
+	int n = 0;
+	int left = len;
+
+	do {
+		current->mosix.commpri = 1;
+		n = sock->ops->recvmsg(sock, msg, left, msg->msg_flags, 0);
+		current->mosix.commpri = 0;
+		if (n <= 0) {
+			/* if we already got -EFAULT, we must report */
+			if (n == -EFAULT) {
+				for ( ; msg->msg_iovlen; msg->msg_iov++,
+							 msg->msg_iovlen--)
+					 len -= msg->msg_iov->iov_len;
+				return (len);
+			}
+
+			/* .. otherwise - it is fatal - return error */
+			if (n < 0) 
+				return (n);
+			return (-EPIPE);
+		}
+
+		left -= n;
+		if (left) {
+			/* ...->recvmsg() updated iovec, we update msg */
+			while (!msg->msg_iov->iov_len) {
+				msg->msg_iov++;
+				msg->msg_iovlen--;
+			}
+		}
+	} while (left);
+	return (len);
+}
+				
+
+/*
+ * comm_recv() - receive a message head
+ */
+int
+comm_recv(void **headp, int *hlen)
+{
+	struct comm_header header;
+	mosix_link *mlink = current->mosix.contact;
+	char *head = 0, *options = 0;
+	struct iovec iov[2];
+	struct msghdr msg =
+		{ NULL, 0, iov, 1, NULL, 0, MSG_WAITALL | MSG_NOSIGNAL };
+	mm_segment_t oldfs;
+	int niov = 0;
+	int size;
+	int error = -EDIST;
+#ifdef CONFIG_MOSIX_DFSA
+	char *dfsadata = NULL;
+#endif /* CONFIG_MOSIX_DFSA */
+
+	if (!mlink)
+	{
+		if (current->mosix.dflags & (DDEPUTY|DREMOTE))
+			panic("comm_recv: null contact\n");
+		return(-EDIST);
+	}
+	DISABLE_EVENTS();
+
+	/* if we're not connected yet we should first accept a connection */
+	if (mlink->flags & COMM_WAITACCEPT) {
+		if (comm_waitaccept())
+			goto edist;
+		mlink = current->mosix.contact;
+	}
+	
+	iov[0].iov_base = &header;
+	iov[0].iov_len  = COMM_HLEN;
+
+
+	oldfs = get_fs();
+	set_fs(KERNEL_DS);
+	if ((error = comm_dorecv(mlink->sock, &msg, COMM_HLEN)) != COMM_HLEN) {
+		if (error >= 0)
+			error = -EFAULT;
+		goto failed;
+	}
+
+	size = header.hlen + header.olen;
+	if (size && !(head = comm_mkhead(size)))
+	{
+		error = -ENOMEM;
+		goto failed;
+	}
+
+	if (header.olen || (header.type & COMM_MFHEADOPTS)) {
+
+		/* the options will be placed after the message head */
+		options = head + header.hlen;
+		iov[0].iov_base = options;
+		iov[0].iov_len  = header.olen;
+		niov++;
+	}
+	if (header.hlen) {
+		iov[niov].iov_base = head;
+		iov[niov].iov_len  = header.hlen;
+		niov++;
+	}
+	
+	msg.msg_iovlen = niov;
+	if (niov && (error = comm_dorecv(mlink->sock, &msg, size)) != size) {
+		if (error >= 0)
+			error = -EFAULT;
+		goto failed;
+	}
+
+#ifdef CONFIG_MOSIX_DFSA
+	if (header.dfsalen)
+	{
+		if(!(dfsadata = kmalloc(header.dfsalen, GFP_KERNEL)))
+		{
+			printk("%s-comm_recv: failed to allocate DFSA space\n",
+				desc_mostask(NULL));
+			error = -ENOMEM;
+			goto failed;
+		}
+		iov[0].iov_base = dfsadata;
+		iov[0].iov_len = header.dfsalen;
+		msg.msg_iovlen = 1;
+		if ((error = comm_dorecv(mlink->sock, &msg, header.dfsalen)) !=
+								header.dfsalen)
+		{
+			kfree(dfsadata);
+			if (error >= 0)
+				error = -EFAULT;
+			goto failed;
+		}
+	}
+	if(header.type & COMM_MFDFSAOPTS)
+		dfsa_comm_recv(header.type, dfsadata);
+#endif /* CONFIG_MOSIX_DFSA */
+	if (header.type & COMM_MFDATA)
+		mlink->dlen = header.dlen;
+
+	size = 0;
+	if ((header.type & COMM_MFREGS) &&
+			(size = comm_unpackregs(&header, options)) < 0) {
+		goto edist;
+	}
+	options += size;
+	if ((header.type & COMM_MFIDENT) &&
+			(size = comm_unpackident(options)) < 0) {
+		goto edist;
+	}
+	options += size;
+	error = header.type & ~COMM_MFOPTIONS;	/* return value :-) */
+	if (hlen)
+		*hlen = header.hlen;
+
+	goto done;
+
+edist:
+	error = -EDIST;
+failed:
+	if (head)
+		comm_free(head);
+	comm_shutdown(mlink);
+	head = NULL;
+done:
+	/* the caller knows what she wants; from the type she knows the
+	   message is empty, and will not free it -> we do it ourselves */
+	if (!header.hlen) {
+		comm_free(head);
+		head = NULL;
+	}
+
+	ENABLE_EVENTS();
+	set_fs(oldfs);
+	*headp = head;
+	return (error);
+}
+
+/*
+ * comm_copydata() - copy data from the message (possibly to USPACE)
+ *   if 'uspace': returns 0 on success or result from comm_dorecv()
+ *   else: returns 0 on success, error otherwise (partial read -> panic)
+ */
+int
+comm_copydata(void *data, int len, int uspace)
+{
+	mosix_link *mlink;
+	struct iovec iov;
+	struct msghdr msg =
+		{ NULL, 0, &iov, 1, NULL, 0, MSG_WAITALL | MSG_NOSIGNAL };
+	int error = 0;
+	mm_segment_t oldfs = { 0 };
+	if(uspace && !dirty_all_remote_pages((unsigned long)data, len, 1))
+		return(-ENOMEM);
+	DISABLE_EVENTS();
+
+	mlink = current->mosix.contact;
+	if(mlink->dlen == 0 && mlink->hidebuf)
+	{
+		mlink->flags |= COMM_HIDEDATA;
+		mlink->dlen = mlink->hidelen;
+		mlink->hidelen = 0;
+	}
+
+	if(!mlink->dlen)
+		goto out;
+	len &= ~COMM_ZEROCOPYOK;
+
+	if (mlink->flags & COMM_HIDEDATA) {
+		if (uspace)
+			error = copy_to_user(data, mlink->hideptr, len);
+		else
+			memcpy(data, mlink->hideptr, len);
+		
+		/* NOTE: at this point page-fault *cannot* happen */
+		mlink->dlen -= len;
+		mlink->hideptr += len;
+		if (!mlink->dlen) {
+			kfree(mlink->hidebuf);
+			mlink->hideptr = NULL;
+			mlink->hidebuf = NULL;
+			mlink->flags &= ~COMM_HIDEDATA;
+		}
+		if (error) {
+			error = -EFAULT;
+			goto do_error;
+		}
+		goto out;
+	}
+
+	if (!uspace) {			/* switch to (KSPACE) */
+		oldfs = get_fs();
+		set_fs(KERNEL_DS);
+	}
+
+	iov.iov_base = data;
+	iov.iov_len  = len;
+
+	error = comm_dorecv(mlink->sock, &msg, len);
+
+	if (error == len) {
+		error = 0;
+		mlink->dlen -= len;
+	} else if (error < 0) {
+
+	do_error:
+		if (error != -EFAULT)
+			comm_shutdown(mlink);
+	} else {
+		mlink->dlen -= error;
+		error = len - error;
+	}
+
+	if (!uspace)
+		set_fs(oldfs);
+
+out:
+	ENABLE_EVENTS();
+	return (error);
+}
+
+
+/*
+ * comm_recvdata() - receive entire data to an allocated buffer 
+ */
+int
+comm_recvdata(void **data)
+{
+	mosix_link *mlink;
+	char *buf;
+	struct iovec iov;
+	struct msghdr msg =
+		{ NULL, 0, &iov, 1, NULL, 0, MSG_WAITALL | MSG_NOSIGNAL};
+	mm_segment_t oldfs;
+	int error = 0;
+
+	DISABLE_EVENTS();
+
+	mlink = current->mosix.contact;
+	if(mlink->dlen == 0 && mlink->hidebuf)
+	{
+		mlink->flags |= COMM_HIDEDATA;
+		mlink->dlen = mlink->hidelen;
+		mlink->hidelen = 0;
+	}
+
+	/* data was hidden: simply hand the hidden data to the caller */
+	if (mlink->flags & COMM_HIDEDATA) {
+		/* actually, we never reach here in real-life */
+
+		*data = mlink->hidebuf;
+
+		/* test for the pathologic case of calling comm_recvdata()
+		   after a partial call to comm_copydata() ...*/
+		if (mlink->hidebuf != mlink->hideptr)
+			panic("comm_recvdata: hide pathology");
+
+		mlink->hideptr = NULL;
+		mlink->hidebuf = NULL;
+
+		goto out;
+	}
+
+	buf = comm_malloc(mlink->dlen);
+	iov.iov_base = buf;
+	iov.iov_len  = mlink->dlen;
+	oldfs = get_fs();
+	set_fs(KERNEL_DS);
+	error = comm_dorecv(mlink->sock, &msg, mlink->dlen);
+	set_fs(oldfs);
+	if (error != mlink->dlen) {
+		if (error >= 0)
+			error = -EFAULT;
+		kfree(buf);
+		comm_shutdown(mlink);
+		*data = 0;
+	} else {
+		error = 0;
+		*data = buf;
+	}
+
+out:
+	mlink->dlen = 0;
+	ENABLE_EVENTS();
+
+	return (error);
+}
+
+
+/*
+ * comm_hidedata() - hide data (possibly exisiting) in the socket,
+ * to allow the socket to be used for a page-fault. The data is put
+ * in a buffer pointed to by comm->hide.
+ */
+int
+comm_hidedata()
+{
+	mosix_link *mlink;
+	struct iovec iov;
+	struct msghdr msg =
+		{ NULL, 0, &iov, 1, NULL, 0, MSG_WAITALL | MSG_NOSIGNAL};
+	mm_segment_t oldfs;
+	int error = 0;
+
+	mlink = current->mosix.contact;
+
+	/* if already hidden, or no data - return */
+	if (mlink->hidebuf || !mlink->dlen)
+		return(0);
+
+	DISABLE_EVENTS();
+
+	mlink->hideptr = mlink->hidebuf = comm_malloc(mlink->dlen);
+
+	iov.iov_base = mlink->hidebuf;
+	iov.iov_len  = mlink->dlen;
+	oldfs = get_fs();
+	set_fs(KERNEL_DS);
+	error = comm_dorecv(mlink->sock, &msg, mlink->dlen);
+	set_fs(oldfs);
+	if (error != mlink->dlen) {
+		comm_shutdown(mlink);
+	} else
+		error = 0;
+	mlink->hidelen = mlink->dlen;
+	mlink->dlen = 0;
+	ENABLE_EVENTS();
+
+	return (error);
+}
+
+/*
+ * comm_flushdata() - flush remaining data from previous message
+ */
+void
+comm_flushdata(int dlen)
+{
+	mosix_link *mlink;
+	struct iovec iov;
+	struct msghdr msg = { NULL, 0, &iov, 1, NULL, 0, 0 };
+	mm_segment_t oldfs;
+	int n = 0;
+#define COMM_FLUSH_BUF_SIZE	256
+	static char comm_flush_buffer[COMM_FLUSH_BUF_SIZE];	/* global bin */
+
+	mlink = current->mosix.contact;
+	if(mlink->dlen == 0 && mlink->hidebuf)
+	{
+		mlink->flags |= COMM_HIDEDATA;
+		mlink->dlen = mlink->hidelen;
+		mlink->hidelen = 0;
+	}
+	if (dlen == COMM_ALLDATA && !(dlen = mlink->dlen))
+		return;
+
+	if (mlink->flags & COMM_HIDEDATA) {
+		mlink->hideptr += mlink->dlen;
+		mlink->dlen -= dlen;
+		if (!mlink->dlen) {
+			kfree(mlink->hidebuf);
+			mlink->hidebuf = NULL;
+			mlink->hideptr = NULL;
+			mlink->flags &= ~COMM_HIDEDATA;
+		}
+		return;
+	}
+
+	DISABLE_EVENTS();
+
+	oldfs = get_fs();
+	set_fs(KERNEL_DS);
+	while (dlen)
+	{
+		iov.iov_base = comm_flush_buffer;
+		iov.iov_len = (dlen < COMM_FLUSH_BUF_SIZE) ? dlen :
+							COMM_FLUSH_BUF_SIZE;
+		msg.msg_flags = MSG_WAITALL | MSG_NOSIGNAL;
+		if ((n = comm_dorecv(mlink->sock, &msg, iov.iov_len)) <= 0)
+			break;
+		dlen -= n;
+		mlink->dlen -= n;
+	}
+	set_fs(oldfs);
+	if (n <= 0) {
+		comm_shutdown(current->mosix.contact);
+	}
+	ENABLE_EVENTS();
+}
+
+
+#define POLLIN_SET	(POLLRDNORM | POLLRDBAND | POLLIN | POLLHUP | POLLERR)
+
+/*
+ * comm_peek() - peek the socket looking for data pending 
+ */
+int
+comm_peek(void)
+{
+	struct socket *sock;
+	int mask;
+
+	sock = current->mosix.contact->sock;
+		
+	mask = sock->ops->poll(NULL, sock, NULL);
+	return ((mask & POLLIN_SET) ? 1 : 0);
+}
+
+
+/*
+ * comm_poll() - wait for a communication event, interrupt or openMosix event
+ * returns 1 on communication events, and 0 otherwise
+ */
+static int
+comm_poll(int mask, int interruptible, unsigned long timo)
+{
+	struct socket *sock;
+	int pollmask;
+	static struct file sighfile = {.f_count = ATOMIC_INIT(1)};
+	DECLARE_WAITQUEUE(wait, current);
+
+	/*
+	 * sighfile: we are required to supply a file to "hold" while we poll.
+	 * a bit ridiculous in this context, but nobody will notice because
+	 * f_count will never drop to 0
+	 */
+	sock = current->mosix.contact->sock;
+	if(!timo)
+		timo = MAX_SCHEDULE_TIMEOUT;
+	add_wait_queue(sock->sk->sleep, &wait);
+	for (;;) {
+		set_current_state(TASK_INTERRUPTIBLE);
+		pollmask = sock->ops->poll(&sighfile, sock, NULL);
+		if ((pollmask & mask) ||
+		    (interruptible && signal_pending(current)))
+			break;
+		current->mosix.commpri = 1;
+		timo = schedule_timeout(timo);
+		current->mosix.commpri = 0;
+		if (timo <= 0)
+			break;
+	}
+	remove_wait_queue(sock->sk->sleep, &wait);
+	set_current_state(TASK_RUNNING);
+	return ((pollmask & mask) ? 1 : 0);
+}
+
+
+/*
+ * comm_wait() - wait for a message, or some other openMosix event
+ * return 1 if there is a message, 0 if another event occured first.
+ */
+int
+comm_wait(void)
+{
+	return (comm_poll(POLLIN_SET, 1, 0UL));
+}
+
+/*
+ * comm_send_urgent() - send notification using urgent data (OOB)
+ */
+int
+comm_send_urgent(void)
+{
+	struct iovec iov;
+	struct msghdr msg = { NULL, 0, &iov, 1, NULL, 0, MSG_OOB|MSG_NOSIGNAL };
+	mm_segment_t oldfs;
+	int error;
+	unsigned char dummy;
+
+	dummy = 0xdb;
+	iov.iov_base = &dummy;
+	iov.iov_len  = 1;
+
+	oldfs = get_fs();
+	set_fs(KERNEL_DS);
+
+	error = current->mosix.contact->sock->ops->
+			sendmsg(current->mosix.contact->sock, &msg, 1, 0);
+
+	set_fs(oldfs);
+
+	return(0);
+}
+
+/*
+ * comm_test_urgent() - test if urgent data is pending (OOB)
+ */
+int
+comm_test_urgent(void)
+{
+
+	return(test_bit(SOCK_OOB_IN, &current->mosix.contact->sock->flags));
+}
+
+/*
+ * comm_take_urgent() - take the pending OOB out of the stream,
+ *   preventing it from turning into a normal byte.
+ *   Caller must make sure that there is no other data in the stream.
+ */
+void
+comm_take_urgent(void)
+{
+	int was;
+	was = test_and_clear_bit(SOCK_OOB_IN,
+					&current->mosix.contact->sock->flags);
+
+}
+
+void
+mosix_notify_urgent(struct socket *sock)
+{
+	struct task_struct *p;
+
+	set_bit(SOCK_OOB_IN, &sock->flags);
+	if (!(p = find_task_by_sock(sock)))
+		return;
+	spin_unlock(&skown_lock);
+	if (p->mosix.dflags & DDEPUTY)
+	{
+		tell_process(p, DREQ_URGENT);
+		wake_up_mosix(p);
+	}
+	free_task_struct(p);
+}
+
+void
+mosix_notify_receive(struct socket *sock)
+{
+	struct task_struct *p = find_task_by_sock(sock);
+
+	if(!p)
+		return;
+#ifdef CONFIG_MOSIX_FS
+	if(p == mfs_main_server_task)
+	{
+		spin_unlock(&skown_lock);
+		mfs_new_request_arrived();
+		goto free_task;
+	}
+	if(test_bit(SOCK_WAIT_MFSDATA, &sock->flags))
+	{
+		spin_unlock(&skown_lock);
+		wake_up_process(p);
+		goto free_task;
+	}
+#endif /* CONFIG_MOSIX_FS */
+	spin_unlock(&skown_lock);
+
+	if(!(p->mosix.dflags & DREMOTE))
+	{
+		if (!(p->mosix.dflags & (DDEPUTY|DREMOTEDAEMON|DFINISHED)))
+			printk("mosix_notify_receive: pid = %d, "
+				"not DEPUTY or REMOTE\n", p->pid);
+		goto free_task;
+	}
+
+	p->mosix.commpri = 1;
+	current->need_resched = 1;
+	wake_up_mosix(p);
+	free_task:
+	free_task_struct(p);
+}
+
+/*
+ * comm_sendto() - send a datagram to someone
+ */
+int
+comm_sendto(int mos, void *data, int len, mosix_link *mlink, mosix_addr *to)
+{
+	struct iovec iov = {data, len};
+	struct sockaddr sa;
+	struct msghdr msg = {NULL, 0, &iov, 1, NULL, 0, MSG_NOSIGNAL};
+	mm_segment_t oldfs;
+	int error = -EDIST;
+
+	if (to)
+		sa = to->saddr;
+	else if (!comm_set_address(-mos, &sa, 0))
+		return (error);
+
+	msg.msg_name = &sa;
+	msg.msg_namelen = sizeof(sa);
+
+	oldfs = get_fs();
+	set_fs(KERNEL_DS);
+
+	error = mlink->sock->ops->sendmsg(mlink->sock, &msg, len, NULL);
+
+	set_fs(oldfs);
+
+	return (error);
+}
+
+
+/*
+ * comm_recvfrom() - receive a datagram from someone
+ * NOTE NOTE NOTE:  the timeout is in microseconds -- NOT ticks!
+ */
+int
+comm_recvfrom(void *data, int len, mosix_link *mlink, mosix_addr *from,
+	unsigned long timo)
+{
+	struct iovec iov = {data, len};
+	struct msghdr msg = { &from->saddr, sizeof(struct sockaddr),
+			      &iov, 1, NULL, 0, 0 };
+	mm_segment_t oldfs;
+	int error;
+	int nrecv = len, msgflg = 0;
+	DECLARE_WAITQUEUE(wait, current);
+
+	if(timo)
+	{
+#if MILLION % HZ
+		timo = timo * HZ / MILLION;
+#else
+		timo = timo / (MILLION/HZ);
+#endif
+	}
+	oldfs = get_fs();
+	set_fs(KERNEL_DS);
+
+	if (timo)
+		msgflg |= MSG_DONTWAIT;
+	else
+		timo = MAX_SCHEDULE_TIMEOUT;
+
+	add_wait_queue(mlink->sock->sk->sleep, &wait);
+	while (1) {
+		set_current_state(
+			msgflg ? TASK_UNINTERRUPTIBLE : TASK_INTERRUPTIBLE);
+
+		error = mlink->sock->ops->recvmsg(mlink->sock, &msg,
+							nrecv, msgflg, 0);
+		if(error >= 0 && !net_to_mos((mosix_addr *)&from->saddr))
+		{
+			comm_report_violation("information", &from->saddr);
+			error = -EPERM;
+			break;
+		}
+		if (error > 0)
+			break;
+
+		if (msgflg && timo <= 0) {
+			error = -EWOULDBLOCK;
+			break;
+		}
+
+		timo = schedule_timeout(timo);
+
+		if (signal_pending(current)) {
+			error = -EINTR;
+			break;
+		}
+	}
+	remove_wait_queue(mlink->sock->sk->sleep, &wait);
+	set_current_state(TASK_RUNNING);
+	set_fs(oldfs);
+	
+	if (msg.msg_flags & MSG_TRUNC) {
+		error = -EDIST;
+	}
+	
+	return (error);
+}
+
+
+/*
+ * comm_recvfrompe() - wrapper for comm_recvfrom, fills in mosix id
+ * instead of source address.
+ * NOTE NOTE NOTE:  the timeout is in microseconds -- NOT ticks!
+ */
+int
+comm_recvfrompe(void *data, int len, mosix_link *mlink,
+				  int *from, unsigned long timo)
+{
+	int error;
+	struct mosix_addr maddr;
+
+	error = comm_recvfrom(data, len, mlink, from ? &maddr : NULL, timo);
+	if (from)
+		*from = net_to_mos(&maddr);
+	return (error);
+}
+
+
+/*
+ * routines for debugging (can call from debugger)
+ */
+inline void
+comm_invalidate_address(mosix_addr *ma)
+{
+	ma->saddr.sa_family = AF_UNSPEC;
+}
+
+
+static inline struct socket *
+comm_set_address(int mos, struct sockaddr *sa, int makesock)
+{
+	switch (comm_type) {
+	case AF_INET:
+		return (comm_ip_set_addr(mos, sa, makesock));
+		/* NOT REACHED */
+	case AF_UNSPEC:
+		if (mos == COMM_TOADDR)
+			return (0);
+		/* FALL THROUGH */	
+	default:
+		panic("comm_set_address: unknown comm_type");
+		return(0);
+	}
+}
+
+
+/*
+ * comm_getname: fill in our name
+ */
+static int
+comm_getname(struct socket *sock, struct sockaddr *saddr)
+{
+	switch (comm_type) {
+		case AF_INET:
+			return (comm_ip_getname(sock, saddr));
+			break;
+		default:
+			panic("comm_getname: invalid comm_type");
+	}
+}
+
+/*
+ * comm_shutdown: shutdown socket
+ */
+static void
+comm_shutdown(mosix_link *mlink)
+{
+	struct socket *sock;
+	if (!mlink)
+		return;
+	sock = mlink->sock;
+
+	spin_lock_irq(&skown_lock);
+	sock->sk->owner = NULL;
+	clear_bit(SOCK_INTER_MOSIX, &sock->flags);
+	spin_unlock_irq(&skown_lock);
+	if (mlink->flags & COMM_FULLLINK) {
+		if (mlink->hidebuf) {
+			kfree(mlink->hidebuf);
+			mlink->hidebuf = NULL;
+			mlink->hideptr = NULL;
+			mlink->hidelen = 0;
+		}
+		mlink->dlen = 0;
+	}
+	mlink->flags &= ~(COMM_WAITACCEPT | COMM_HIDEDATA);
+	if (sock->ops)
+		sock->ops->shutdown(sock, SEND_SHUTDOWN);
+}
+
+static inline struct socket *
+comm_ip_set_addr(int mos, struct sockaddr *saddr, int makesock)
+{
+	struct sockaddr_in *sa;
+	struct socket *sock = (struct socket *) 1;	/* xxx - not NULL */
+	int proto = IPPROTO_TCP;
+	int type = SOCK_STREAM;
+	unsigned short port = MIG_DAEMON_PORT;
+
+	sa = (struct sockaddr_in *) saddr;
+	switch (mos) {
+	case COMM_LOOSE:
+		type = SOCK_DGRAM;
+		proto = IPPROTO_UDP;
+		port = INFO_DAEMON_PORT;
+		break;
+	case COMM_TOADDR:
+		/* address was set by the caller */
+		break;
+	case COMM_INFO:
+		proto = IPPROTO_UDP;
+		type = SOCK_DGRAM;
+		/* fall through */
+	case COMM_MIGD:
+		memset((void *)sa, 0, sizeof(struct sockaddr_in));
+	        sa->sin_family = AF_INET;
+		sa->sin_addr.s_addr = INADDR_ANY;
+		if (mos == COMM_MIGD)
+			sa->sin_port = MIG_DAEMON_PORT;
+		else
+			sa->sin_port = INFO_DAEMON_PORT;
+		break;
+	case COMM_ACCEPT:
+		memset((void *)sa, 0, sizeof(struct sockaddr_in));
+	        sa->sin_family = AF_INET;
+		sa->sin_addr.s_addr = INADDR_ANY;
+		sa->sin_port = 0;
+		break;
+	default:
+		if (mos < 0) {
+			type = SOCK_DGRAM;
+			proto = IPPROTO_UDP;
+			port = INFO_DAEMON_PORT;
+			mos = -mos;
+		}
+
+		if (!mos_to_net(mos, saddr)) {
+			return (0);
+		}
+		sa->sin_port = port;
+		break;
+	}
+
+	if (makesock && sock_create(AF_INET, type, proto, &sock)) {
+		return (0);
+	}
+
+	return (sock);
+}
+
+
+/*
+ * comm_ip_getname: fill in our name
+ */
+static inline int
+comm_ip_getname(struct socket *sock, struct sockaddr *saddr)
+{
+	int val;
+	struct sockaddr_in sa;
+	int error;
+
+	val = sizeof(sa);
+	error = sock->ops->getname(sock, (struct sockaddr *)&sa, &val, 0);
+	if(!error)
+	{
+		error = mymos_to_net((void *)saddr);
+		((struct sockaddr_in *)saddr)->sin_port = sa.sin_port;
+	}
+	return (error);
+}
+
+
+/*
+ * comm_migration_mode() - setup parameters for migration mode (on/off)
+ */
+void
+comm_migration_mode(int on)
+{
+	switch (comm_type) {
+	case AF_INET:
+		comm_ip_migration_mode(on);
+		break;
+	default:
+		panic("comm_setup_socket: unknown comm_type");
+	}
+}
+
+
+/*
+ * comm_ip_migration_mode() - setup parameters for migration mode (on/off)
+ */
+void
+comm_ip_migration_mode(int on)
+{
+	int val = on ? 0 : 1;
+	mm_segment_t oldfs;
+	int error;
+
+	oldfs = get_fs();
+	set_fs(KERNEL_DS);
+
+	error = current->mosix.contact->sock->ops->setsockopt(
+		current->mosix.contact->sock, IPPROTO_TCP,
+		TCP_NODELAY, (char *) &val, sizeof(val));
+
+	set_fs(oldfs);
+}
+
+
+void
+comm_data_ready(struct sock *sk, int len)
+{
+	wake_up_interruptible(sk->sleep);
+}
+
+
+int
+comm_getpeer(mosix_link *mlink)
+{
+	return (mlink->peer);
+}
+
+
+#define MAX_LINK_POOL	30
+#define MIN_LINK_POOL	2
+#define LINK_POOL_AGE	60
+
+static int link_pool_age = LINK_POOL_AGE;
+
+static struct {
+	mosix_link *mlink;
+	int age;
+} link_pool[MAX_LINK_POOL];
+
+spinlock_t linkpool_lock = SPIN_LOCK_UNLOCKED;
+static atomic_t link_pool_used = ATOMIC_INIT(0);
+static int link_pool_next = 0;
+static int linkpool_closed = 1;
+DECLARE_WAIT_QUEUE_HEAD(wait_for_link_pool_used);
+
+void
+comm_init_linkpool(void)
+{
+	unsigned int i;
+
+	for(i = 0 ; i < MIN_LINK_POOL ; i++)
+	if (!(link_pool[i].mlink = comm_open(COMM_LOOSE, NULL, 0)))
+		break;
+	link_pool_next = i;
+	linkpool_closed = 0;
+}
+
+void
+comm_free_linkpool(void)
+{
+	unsigned int i;
+
+	spin_lock(&linkpool_lock);
+	linkpool_closed = 1;
+	spin_unlock(&linkpool_lock);
+	wake_up(&wait_for_link_pool_used);
+	for (i = 0 ; i < link_pool_next ; i++)
+		comm_close(link_pool[i].mlink);
+	link_pool_next = 0;
+}
+
+mosix_link *
+comm_borrow_linkpool()
+{
+	mosix_link *mlink;
+
+	while(1)
+	{
+		spin_lock(&linkpool_lock);
+		if(linkpool_closed)
+		{
+			spin_unlock(&linkpool_lock);
+			return(NULL);
+		}
+		if(link_pool_next)
+		{
+			mlink = link_pool[--link_pool_next].mlink;
+			atomic_inc(&link_pool_used);
+			spin_unlock(&linkpool_lock);
+			return(mlink);
+		}
+		if(atomic_read(&link_pool_used) <= MAX_LINK_POOL)
+		{
+			spin_unlock(&linkpool_lock);
+			atomic_inc(&link_pool_used);
+			if(!(mlink = comm_open(COMM_LOOSE, NULL, 0)))
+			{
+				atomic_dec(&link_pool_used);
+				wake_up(&wait_for_link_pool_used);
+			}
+			return(mlink);
+		}
+		spin_unlock(&linkpool_lock);
+		sleep_on_timeout(&wait_for_link_pool_used, HZ/10);
+		if (signal_pending(current))
+			return(NULL);
+	}
+}
+
+
+void
+comm_return_linkpool(mosix_link *mlink)
+{
+	atomic_dec(&link_pool_used);
+	spin_lock(&linkpool_lock);
+	if (!linkpool_closed &&
+		link_pool_next + atomic_read(&link_pool_used) <= MAX_LINK_POOL)
+	{
+		link_pool[link_pool_next].mlink = mlink;
+		link_pool[link_pool_next].age = link_pool_age;
+		link_pool_next++;
+		spin_unlock(&linkpool_lock);
+	}
+	else
+	{
+		spin_unlock(&linkpool_lock);
+		comm_close(mlink);
+	}
+	wake_up(&wait_for_link_pool_used);
+}
+
+
+void
+comm_age_linkpool()
+{
+	register int i;
+	struct mosix_link *mlink;
+
+	spin_lock(&linkpool_lock);
+	for(i = MIN_LINK_POOL ; i < link_pool_next ; )
+	if(--link_pool[i].age <= 0)
+	{
+		mlink = link_pool[i].mlink;
+		link_pool[i] = link_pool[--link_pool_next];
+		spin_unlock(&linkpool_lock);
+		comm_close(mlink);
+		spin_lock(&linkpool_lock);
+	}
+	else
+		i++;
+	spin_unlock(&linkpool_lock);
+}
+
+int
+reserved_mosix_address(struct sockaddr *addr)
+{
+	int port = ((struct sockaddr_in *)addr)->sin_port;
+
+	if(port != MIG_DAEMON_PORT && port != INFO_DAEMON_PORT)
+#ifdef CONFIG_MOSIX_FS
+	if(port != MFS_MAIN_PORT)
+#endif /* CONFIG_MOSIX_FS */
+		return(0);
+	if(current->mosix.dflags & (DPASSING|DHEAVYSLEEP))
+		return(0);
+#ifdef CONFIG_MOSIX_SECUREPORTS
+	if(!capable(CAP_NET_RAW))
+		return(1);
+#endif /* CONFIG_MOSIX_SECUREPORTS */
+	if (!net_to_mos((mosix_addr *)addr))
+		return(0);
+#ifndef CONFIG_MOSIX_SECUREPORTS
+	if(!capable(CAP_NET_RAW))
+		return(1);
+#endif /* CONFIG_MOSIX_SECUREPORTS */
+	printk("The Super-User is allowed to access openMosix ports -- "
+						"but it is not a good idea!\n");
+	return(0);
+}
+
+void
+debug_commdump(int pid)
+{
+	struct task_struct *p = 0;
+	struct socket *sock = 0 ;
+	mosix_link *mlink = 0;
+
+	if (pid == -1)
+		p = current;
+	else for_each_task(p)
+		if (p->pid == pid)
+			break;
+	if (p) {
+		mlink = p->mosix.contact;
+		if (mlink)
+			sock = mlink->sock;
+		else
+			sock = NULL;
+		printk("task=0x%x, socket=0x%x, sock=0x%x, mlink=0x%x\n",
+			(int)p, (int)sock, sock ? (int)sock->sk : 0,(int)mlink);
+		if (sock)
+			printk("socket-flags=0x%x, owner=%x\n",
+				(int)sock->flags, (int)sock->sk->owner);
+		if (mlink) {
+			printk("mlink:  dlen=%d  flags=0x%x  peer=0x%x",
+				mlink->dlen, mlink->flags, (int)mlink->peer);
+			printk("\n");
+		}
+	} else
+		printk("X: %s\n", current ? "no such pid" : "no current task");
+}
